#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityKingCraftSignCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityKingCraftSignCFG> M_ActivityKingCraftSignCFG::msSingleton(nullptr);

int M_ActivityKingCraftSignCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityKingCraftSignCFGData* M_ActivityKingCraftSignCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityKingCraftSignCFGData>& M_ActivityKingCraftSignCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityKingCraftSignCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityKingCraftSignCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityKingCraftSignCFGData data;
		data.mDay = element->IntAttribute("Day");
		{
			const char* Item = element->Attribute("Item");
			std::vector<std::string> vecItem;
			boost::split(vecItem, Item, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItem[i].c_str(), &temp))
				{
					data.mItem.push_back(temp);
				}
			}
		}
		{
			const char* Count = element->Attribute("Count");
			std::vector<std::string> vecCount;
			boost::split(vecCount, Count, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCount[i].c_str(), &temp))
				{
					data.mCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		assert(mMapData.find(data.mDay) == mMapData.end());
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityKingCraftSignCFG::Load()
{
	Load("../Config/M_ActivityKingCraftSignCFG.xml");
}

M_ActivityKingCraftSignCFG* M_ActivityKingCraftSignCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityKingCraftSignCFG());
	}
	return msSingleton.get();
}
